//******************************************//
// DDS_9859 controll program				// 
// program by yokoshima psoc24794			//
// version 1.0.0							//
// revide history							//
//******************************************//
//
#include <m8c.h>        
#include "PSoCAPI.h" 
#include <stdlib.h>							//use float
#pragma interrupt_handler  system_timer	 	//ｼｽﾃﾑﾀｲﾏｰ 1msec ﾀｲﾏ-	
#pragma interrupt_handler  system_timer1    //Am,Fm 変調用 0.1msec ﾀｲﾏｰ

/*	port setting	*/
//
//p00--none			p01--none			p02--none			p03--none		p04--da amp ofset	p05--none			p06--none			p07--none
//p10--none			p11--none			p12--none			p13--none		p14--r-swA	actLow	p15--r-swB actLow	p16--FuncSW	actLow	p17--Funcs actLow	
//p20--none			p21--none			p22--none			p23--none		p24--none			p25--none			p26--none			p27--none
//p30..37	ｾｸﾞﾒﾝﾄﾄﾞﾗｲﾌﾞ ﾛｳｱｸﾃｨﾌﾞ
//p40--reset		ｱｸﾃｨﾌﾞﾊｲ
//p41--s_data		ｱｸﾃｨﾌﾞﾊｲ
//p42--s_clock		ｱｸﾃｨﾌﾞﾊｲ
//p43--update		ｱｸﾃｨﾌﾞﾊｲ
//p44--osk			ｱｸﾃｨﾌﾞﾊｲ
//p45--no conect
//p46--no conect
//p47--no conect
//p50..57 	ﾃﾞｼﾞｯﾄﾄﾞﾗｲﾌﾞ ｱｸﾃｨﾌﾞﾊｲ
//p70--none			p71--none
//
/*************/
/*  define   */
/*************/
//
#define  vref			4160					//Referrence Voltage 4.16V
#define  rf_gain		2.0						//RF amp Gain(gv=2)
#define  dc_gain		1.6194					//LF amp Gain(200/247)*2 47ohmフィルタ用抵抗値
#define  ad98_ofset		1589					//DDS output Offset <
#define  dac_step_v		8.1409					//DA1Step Voltage(vref/511)=8.1409mv
#define  dac_ini_v		400						//DDS offset cansel DA value(ad98_ofset/200)*210+ad98_ofset)/dac_step_v
#define  dc_step		15.5					//1step Voltage With Dc gain  dc_gain*dac_step_v=8.14*1.90476=15.5047
#define  dac_max		510						//dac_max_value(510-dac_ini_v)*13.18=-975mVMax
#define  dac_min		132						//dac_min_value(dac_ini_v-0)*13.18=+4006mV
#define  dac_stp_ini	1						//1*8.14mV*(200/210)=7.7523mV
#define  dac_step_max	50						//60 60*13
//
#define  base32			4294967296				//dds2^32
#define  clock			25000000*16				//400Mhz
#define  mul			10.73741824				//DDS Clock 2^32/400mhz(25Mhz*16)
#define  mul1			42.94967296				//DDS Clock 2^32/100mhz(25Mhz*4)
#define  mul2			171.79869184			//DDS Clock 2^32/25mhz(25Mhz*1)
#define  f_change_p		1000000					//pll mul change Frequency(100k) 
#define  key_port		PRT1DR					//key_port 
#define  dds_port		PRT4DR					//dds_port							
#define  key_wait_val   0x03					//3msec wait
#define  key_up			0x01					//key up value(clockwise)
#define  key_down		0x02					//key down value(counter clockwise)
#define  key_function0  0x04					//key function0 value
#define  key_function1	0x08					//key function1 value
#define	 key_long_500	500						//long key Judge value 500msec			
#define  key_long_1000	1000					//long key Judge value 1000msec
#define  key_long_1500	1500					//long key Judge value 1500msec
#define  key_long_1750	1750					//long key Judge value 1750msec
//
#define  dds_rst		0x01    				//dds reset active high 
#define  dds_dt			0x02					//ddt serial data 		(SPI dt)
#define  dds_clk		0x04					//dds serial clock      (SPI clock)			
#define  dds_update		0x08					//dds data update
#define  dds_osk		0x10					//dds osk
#define  CFR1			0x00					//dds cfr1 adr 32bit
#define  CFR1_OSK_EN	0x02000000				//dds osk enable
#define  CFR1_OSK_AUTO	0x01000000				//dds osk Auto
#define  CFR1_phase_clr	0x00002000				//dds phase clr
#define  CFR2			0x01					//dds cfr2 adr 24 bit
#define  ASF			0x02					//dds asf  adr 16 bit
#define  ARR			0x03					//dds arr  adr 8bit
#define  FTW0			0x04					//dds ftw0 adr 32bit
#define  POW0			0x05					//dds pow0 adr 16bit
#define  cfr1_ini		0x02001200				//sin_reg0,osk eable
#define	 cfr2_ini		0x000284				//x16,xtal_out,pll_250~400Mhz
#define  cfr2_low		0x000208				//X1,xtal_out,pll_vco_off,DDS ck is 25Mhz
#define	 asf_ini		0x24e9					//out scall max,lamp decregi=0 /(447/775)*2^14
#define  asf_maxvalue	0x3fff					//asf max value
#define	 arr_ini		0x0						//lamp min
#define	 ftw0_ini		0x029f1					//1Khz
#define	 pow0_ini		0x0000					//phase
#define  pow_maxvalue	0x3fff					//pow max_value
#define  phase_max		360						//phase max
#define  phase_10		455						//phase 10° 	
//
#define  f_max			1990000000				//dds max frequency
#define  f_shift_max	100000000				//f_shift max 10Mmax over reset
#define  f_min			1						//dds min frequency
#define  frequency_ini  10000					//Frequency initial f*10 1000hz
#define  fbase_max		10000000				//dds max step(10M) f*10
#define  fstep_ini		1						//dds step mul .1hz
#define  fstep_ini_10s	0						//dds step mul for display 10^-1
#define  fstep_base		10						//dds step base
#define	 fstep_mul_ini  1						//frequency step multiply initial value
#define	 fstep_mul_max  9						//frequency step multiply max value
#define  out_db_ini		47						//out att=0db/m ini
#define  out_step_ini	1						//out step ini  1=0.1db,10=1.0db,30=3db,.......
#define  out_db_min		0						//out att min value
#define  out_db_max		600						//out att max value real att=value/10 600->60db	
#define  log1db			1.1220185				//log 1db value NOW non use!!
#define  log0_1db		1.0115795				//log 0.1db value
//
#define  swp_start_val  100						//sweep start initial f*10 10hz
#define  swp_end_val    200000					//sweep end	initial	  f*10 20khz		
#define  swp_step_val	10						//sweep step initial  f*10   1hz
#define  modu_level_ini 30						//AM,FM modulation lebel initial
#define  fm_mod_limit   5000000					//fm modulation low limit f*10 500khz
#define  burst_on_ini   10						//burst on time initial 1msec step
#define  burst_on_step  1						//burst on time step
#define  burst_on_max   99						//burst on time max 99msec
#define  burst_rp_ini	100						//burst repeat time initial
#define  burst_rp_max   2500					//burst on time max 250msec
#define  burst_rp_step	10
#define  phase_step		10						//phase step 10° 
#define  lamp_low		164						//asf_set8 lamp_rate (16383/8)/(2500000/2)=0.16368msec_MAX 41.73msec<100khz
#define  lamp_high		82						//asf_set1 lamp_rate (16383/1)/(400000000/2)=0.081915msec_Max 20.88msec>100khz
#define  lamp_off		0						//lamp off value(not use)
#define  lamp_on_value	1						//lamp on  value
#define  lamp_max		254						//41.6msec(20.8msec)	
#define	 function_max	10						//Max FunctionNo
#define  temp			25						//Temperture
//
/****************/
/*    const     */
/****************/
const char  disp_7seg_pat[0x23]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x67,0x77,0x7c,0x35,0x5e,0x79,0x71,
//  								0	 1	  2	   3	4	 5	  6	   7	8 	 9	 10   11   12   13   14   15  	
//  								0	 1	  2	   3	4	 5	  6	   7	8 	 9	  a   b    c    d    E    F  	
						 0x80,0x76,0x04,0x0e,0x74,0x38,0x54,0x5c,0x73,0x50,0x1c,0x3e,0x66,0x01,0x40,0x08,0x00,0043,0061};
//  					 0x10 0x11 0x12 0x13 0x14 0x15 0x16 0x17 0x18 0x19 0x1a 0x1b 0x1c 0x1d 0x1e 0x1f 0x20 0x21 0x22	
//  					   .	H	 i	 J	   h	L	 n	  O	   P	r 	 u	  V   Y 	 ~ 	  -	   _  blk    ^  |~
//
const int	sin_dt[]={0x0000,0x0847,0x0fff,0x169f,0x1bb5,0x1ee7,0x1fff,0x1ee7,0x1bb5,0x169f,0x0fff,0x0847,0x0000};
 					//	0	  15	 30		45		60	  75     90     105	   120    135    150   165	  180//
const long  fsin_dt[]={0x000,0x4bd3,0x927b,0xcf29,0xfdb7,0x11afc,0x124f8,0x11afc,0xfdb7,0xcf29,0x927b,0x4bd3,0x0000};
 					//	0	  15	 30		45		60	  75     90      105	   120    135    150   165	  180//
//
/****************/
/*   variable   */
/****************/
//system&wait
int 		wait_time;							//wait_timer
long 		system_time;						//system timer
long		system_time1;						//system timer1
//DDS//
long		cfr1_buf;							//buffer of dds cfr1 32bit
long		cfr2_buf;							//buffer of dds cfr2 24 bit
int			asf_buf;							//buffer of dds asf 16 bit
char		arr_buf;							//buffer of dds arr 8bit
long		ftw0_buf;							//buffer of dds ftw0 32bit
int			pow0_buf;							//buffer of dds pow0 16bit
long        frequency;							//Now frequency 
char		fstep_mul; 							//frequency step multiply (1-9)   
long 		freq_step;							//freq step fbase*fstep_mul 
long		fbase10x;							//step_base 1,10,100,1khz,10khz,100khz,1Mhz,10Mhz
char		fbase10dis;							//step_base^0,1,2,3,4,5,6,7,8 for only display	
//Sweep//
long		swp_start;							//sweep start frequency
long		swp_end;							//sweep end   frequency
long		swp_freq;							//sweep frequency
long		swp_step;							//sweep step (nowsetteing step)
char		swp_sel;							//1 sweep start 2-sweep
char		swp_onoff;							//on=1,off=0
//key&select//
char 		key_buf;							//key in buffer
char 		key_flug;							//key_flug o-none,1-key in,2-keywait,3-read rady,4-keyoffwait
char 		key_wait;							//key wait time	bufer
int			keyontim;							//key on continue time(msec)
char		key_longon4;						//key function1 long on function0
char		key_longon8;						//key function2 long on function1
//function&digit
char 		function;							//function 01	Frequency set mode inc&dec & Frequency step 1,10,10^2,10^3,10^4,10^5,10^6,10^7
												//function 02	Frequency step setteng(1~9) 
												//function 03 	out_put offset setting &   ofset step voltage setting
												//function 04	frequency sweep mode
												//function 05	output variable mode 0.1,1,3,5,6,10db step
												//function 06	Amplitude Modulation Mode 10,30,50,100% step
												//function 07	Frequency Modulation Mode 10,30,50,100% step
												//function 08	Burst out mode burst_1~99 1msec step,burst Repeat 100~2500 10msecstep
												//function 09	Burst phase & Lamp mode 0~360 10step
												//function 10	store,recall
//out_offset
int			out_offset;							//dds dc offset buffer
char  		ofset_step;							//dds dc step
//out_put
int			out_db;								//output value	0 to 60db(600)
char		out_step;							//output level step(xxdb) 1 to 100(0.1db=1,10db=100)
//AM,FM Mod data,flug etc,..
int 		sine_out[23];						//sin out data
long 		fsine_out[23];						//sin out data
char		modu_level;							//moduration 10,20,30,50,100
char		mod_flug;							//AM do Flug
char		fmod_flug;							//FM do Flug 	
char		s_step;								//data_counter use interrupt
//Burst etc,..
int 		burst_on_time;						//burst on time 1msec-99msec
int         burst_rp_time;						//burst repeat time 10-250msec
char		burst_func;							//burst on=1,off=0;
int 		burst_on_buf;						//burst on time check
int         burst_rp_buf;						//burst repeat time check
char		asf_lamp;							//asf　lamp
char		phase_out;							//phase buffer
char        phlmp_sel;							//phase lamp change
int			pow0_disp;							//power_dis(display only)
int			lamp_time;							//lamp time
//ep_rom save area
char		e2prom[36];							//0x00,0x00,0x00,0xc8,0x24,0xe9
//e2prom Area No
char		eeprom_no;							//e2prom No
//prot type
void burst_disp(void);							//burst display
void burst_load(void);							//burst load
void dac_dis(void);								//dac offset display
void db_change(int db);							//Value Decibel change
void disp_7seg(char pat,char digit);			//7seg display 1digit
void dds_up_date(void);							//dds update
void e2prom_write(long freq,int amp);			//eeprom read  freq&amplitude save 
void e2prom_read(void);							//eeprom save 
//void eeprom_ini(void);							//eeprom initial
void erase_line(void);							//display erase
void freq_set(long freq);						//dds frequency set
void freq_disp(char disp_start,long freq,char digit);	//frquency disp	
void fsin_set(char mod);						//Make FM sin data set			
void function_set(void);						//function select
void ini_load(void);							//initial load
void ini_amp_set(void);						    //Retun am amplitude
void lamp_disp(void);							//lamp display
void lamp_stop(void);							//lamp stop setting
char mod_div(char mod);							//modlation_divide
void mod_set(char mod);							//modlation lebel setting
void phase_disp(void);							//phase display
void reset_dds(void);							//dds reset
void system_timer(void);						//1msec system timer 
void system_timer1(void);						//0.1msec systemtimer For AM,FM Modulation	
void step_dis(long step);						//frequency step display
void str_disp(char start,char str,char num);	//string_display
void sin_set(char mod);							//Make AM sin data set
void wait(int wait_val);						//wait time 
void write_8bit(char reg);						//dds registor access
void write_8bit(char dt);						//dds 8bit accsess
void write_16bit(int dt);						//dds 16bit accsess
void write_24bit(long dt);						//dds 24bit accsess 
void write_32bit(long dt);						//dds 32bit accsess
void write_asf(void);							//amplitude write
void write_arr(void);							//lamp write
void write_cfr1(void);							//controll1 write
void write_cfr2(void);							//controll2 write
void write_pow(void);							//pow write
void write_ftw(void);							//ftw0 write
//
/*************************/
/****メインルーチン    ***/
/*************************/
void main(void)
{
//port initial 
	PRT1DR=0xf0;								//for input	
	PRT2DR=0x00;								//for test
	PRT4DR=0x00;								//for dds controll,clk=LOW,osk low
	PRT7DR=0x00;								//for test port	
//block start	
	M8C_EnableGInt;
	DAC9_1_Start(DAC9_1_HIGHPOWER);				//dac_start(clock 2Mhz max)
	Timer8_1_EnableInt();						//int enable	
	Timer8_1_Start();							//system timer start
	Timer8_2_Start();							//system timer1 start
	Timer8_2_DisableInt();						//system timer1 disint
	SPIM_1_Start(SPIM_1_SPIM_MODE_0);			//spim start
	E2PROM_1_Start();							//e2prom start
	LED7SEG_1_Start(); 							//Enable display
//	USBUART_1_Start(USBUART_1_5V_OPERATION); 	//Start USBUART 5V operation
//	while(!USBUART_1_Init());	
	M8C_EnableGInt; 							//Enable all IRQ
//key initial	
	key_buf=0;key_flug=0;						//key buf clear
//function & digit initial 	
  	function=1;									//function is 1
//DDS reset
	reset_dds();								//reset dds
	wait(1);
//eeprom																 
	eeprom_no=0;	
//initial_load
	ini_load();									//load initial
/*****************/
/****Main core  **/
/*****************/
key_check:										//key check & key process
/**********************/
/* キーなし処理       */
/**********************/
   
	if(key_flug==0 )	//key off?							
		{
			if (function==1){freq_disp(0,frequency,8);}																				//frequency display only.Must be fset other Routin
			if (function==4){if(swp_onoff==1)																						//sweep
								{freq_set(swp_freq);swp_freq+=swp_step;
								 if(swp_freq>swp_end){swp_freq=swp_start;}}
							}
			if (function==8	||  function==9)																						//Burst&phase&Lamp Function
			{	
								if(burst_func==3 && arr_buf==0)																		//Burst on&Lamp off
									{
								   		if(burst_on_buf==0 && burst_rp_buf!=0){write_8bit(ASF);write_16bit(0);dds_up_date();}		//Burst stop
								   		if(burst_on_buf==0 && burst_rp_buf==0)
								  	   		{																						//Burst setup again
									  			burst_load();lamp_stop();															//timesetup,Lamp off
									  			write_asf();																		//Amplitude SET
												cfr1_buf |=CFR1_phase_clr;
												write_cfr1();dds_up_date();															//DDS phase clear&sinwave set
												
											}	
									}
									
								if(burst_func==3 && arr_buf>=1)																		//when Burst&Lamp on									
									{
										if(burst_on_buf==0 && burst_rp_buf!=0){dds_port&=~dds_osk;}									//Burst stop
								   		if(burst_on_buf==0 && burst_rp_buf==0)
								  	   		{																						//Burst setup again
									  			burst_load();											  							//timesetup,Lamp off
									  			cfr1_buf|=CFR1_OSK_AUTO;cfr1_buf|=CFR1_OSK_EN;										//cfr1 osk enable,auto eabele	
												cfr1_buf |=CFR1_phase_clr;write_cfr1(); 											//DDS phase clear&sinwave set
												write_asf();write_arr();dds_up_date();												//amp&phase write
									  			dds_port|=dds_osk;									  								//osk_on	
											}	

									}
									
							}
		}
/**********************/
/*  キーあり処理      */
/**********************/	
if(key_flug==2)	
{
			if(key_buf==4){function_set();}															//to functionset

	/******************************/
	/*   01  周波数設定			 */
	/******************************/				
			if (function==1	)
				{
	  				switch(key_buf)	
					{
						case 1:	if((frequency+freq_step) >=f_max){frequency=f_max;}					//freq_up
								else{frequency+=freq_step;}freq_set(frequency); break;
	  					case 2:	if((frequency-freq_step) <=f_min){frequency=f_min;}					//freq_down
								else{frequency-=freq_step;}freq_set(frequency); break;
	  					case 4: break;
	  					case 8: //sweep start&end setting
								if(swp_sel==1){swp_start=frequency;str_disp(1,3,3);freq_disp(3,swp_start,5);swp_step=freq_step;}	//sweeep start&step set	
								if(swp_sel==2){swp_end=frequency;str_disp(1,4,3);freq_disp(3,swp_end,5);}							//sweep end set	
								swp_sel+=1;if(swp_sel>2){swp_sel=1;}break;							//frq start & end select
						break;
					}
					if (fmod_flug==1){fsin_set(modu_level);}										//Rebuild Data Table for Fm frequency change			   			
	   			 }
	/********************************/
	/* 02 周波数ステップ、倍率設定  */
	/********************************/
			if (function==2	)
	 		{
				step_dis(freq_step);	//now status disply
	  			switch(key_buf)	
					{				
						case 1:fstep_mul++;if(fstep_mul>fstep_mul_max){fstep_mul=fstep_mul_ini;}  	//frequency step +1  
							   ;break;
	  					case 2:fstep_mul--;if(fstep_mul<fstep_mul_ini){fstep_mul=fstep_mul_max;}  	//frequency step -1 
							   ;break;
	  					case 4:break;
	  					case 8:fbase10x*=fstep_base;fbase10dis++;					   				//fstep base=*10				
								if(fbase10x>fbase_max)								   				//over fbase 10^7?
								  {fbase10x=fstep_ini;fbase10dis=fstep_ini_10s;}		   			//if over fbase 1set&10^0set
								break;
						break;
					}
				step_dis(freq_step);				
				freq_step=fbase10x*(long)fstep_mul;					   								//f step=fbase10xfst_mul								
	   		 }
	/******************************/
	/*   03  出力オフセット設定   */
	/******************************/			 
			if (function==3	)
	 			{	
				dac_dis();				//now display
	  			switch(key_buf)	
					{
						case 1:out_offset-=ofset_step;if(out_offset<=dac_min){out_offset=dac_min;}	//offset down(out_up)
								dac_dis();break;
						case 2:out_offset+=ofset_step;if(out_offset>=dac_max){out_offset=dac_max;}	//offset up(out_down)
								dac_dis();break;
						case 4:break;
	  					case 8:ofset_step*=2;if(ofset_step>=dac_step_max){ofset_step=dac_stp_ini;}  //step set 20,40,80,160
								str_disp(1,2,4);LED7SEG_1_DispInt(ofset_step*dc_step,5,3);break;
						break;
					}
					
					
	   		 }
	/******************************/
	/*    04 スイープオンオフ     */
	/******************************/		 
		 
			if (function==4	)  
			{	
				str_disp(1,6,6);
	  			switch(key_buf)	
					{
						case 1:swp_onoff=1;swp_freq=swp_start;str_disp(1,5,7);break;		//スタート＆表示＆フラグセット
	  					case 2:swp_onoff=0;str_disp(1,6,6);freq_set(frequency);break;		//ストップ＆表示＆フラグクリヤー＆周波数を戻す
	  					case 4:break;
	  					case 8:break;
						break;
					}	
	   		 }
	/******************************/
	/*    05 アンプリチュード 	  */
	/******************************/			 
			if (function==5	)
	 		{
				db_change(out_db);		//display&write
	  			switch(key_buf)	
					{
						case 1:out_db=out_db-out_step;if(out_db<out_db_min){out_db=out_db_min;}db_change(out_db);break;
	  					case 2:out_db=out_db+out_step;if(out_db>out_db_max){out_db=out_db_max;}db_change(out_db);break;
	  					case 4:break;
	  					case 8:	switch(out_step)
									{
									  case(1) :out_step=10;break;
									  case(10):out_step=30;break;
									  case(30):out_step=50;break;
									  case(50):out_step=60;break;
									  case(60):out_step=100;break;
									  case(100):out_step=1;break;
									  break;
									}
									LED7SEG_1_DispInt(out_step,4,3);LED7SEG_1_DP(1,5);
						break;
					}
			}
	/******************************/
	/*    06 ＡＭ変調設定         */
	/******************************/
	if (function==6	)           
	 		{
				str_disp(1,9,4);LED7SEG_1_DispInt(modu_level,6,3);
				switch(key_buf)	
					{
						case 1:mod_flug=1;sin_set(modu_level);fmod_flug=0;break; 			//AM set&FM Disable & AM sine Data make
	  					case 2:mod_flug=0;Timer8_2_DisableInt();							//Modlation Stop,Disable interrupt
							   freq_set(frequency);ini_amp_set();	  						//frequency & amplitude return
							   break;
	  					case 4:break;
	  					case 8:mod_set(modu_level);									
							   str_disp(1,9,4);LED7SEG_1_DispInt(modu_level,6,3);					//Select modulation Display			
						break;
					}
			}		
	/******************************/
	/*     07 ＦＭ変調設定	    */
	/******************************/
	if (function==7	) 
	 		{
				str_disp(1,10,4);LED7SEG_1_DispInt(modu_level,6,3);	
				switch(key_buf)	
					{
						case 1:fmod_flug=1;fsin_set(modu_level);mod_flug=0;break;  			//FM sin_data make,AM disable、
	  					case 2:fmod_flug=0;Timer8_2_DisableInt();							//Modlation Stop,Disable interrupt
							   freq_set(frequency);dds_up_date();		   					//return condition
							   break;
	  					case 4:break;
	  					case 8:mod_set(modu_level);									
							   str_disp(1,10,4);LED7SEG_1_DispInt(modu_level,6,3);			
						break;
					}
			}		

	/******************************/
	/*   08 バースト設定          */
	/******************************/
	if (function==8	) 
	 		{	
				burst_disp();
				switch(key_buf)	
					{
						case 1:if(burst_func==1){burst_on_time+=burst_on_step;if(burst_on_time>burst_on_max){burst_on_time=burst_on_max;}burst_disp();}
							   if(burst_func==2){burst_rp_time+=burst_rp_step;if(burst_rp_time>burst_rp_max){burst_rp_time=burst_rp_max;}burst_disp();}
							   break;														//Burst time Up & display	
	  					case 2:if(burst_func==1){burst_on_time-=burst_on_step;if(burst_on_time<1){burst_on_time=1;}burst_disp();}
							   if(burst_func==2){burst_rp_time-=burst_rp_step;if(burst_rp_time<burst_rp_ini){burst_rp_time=burst_rp_ini;}burst_disp();}
							   break;														//Burst time Down & display
	 					case 4:break;
	  					case 8:switch(burst_func)											//burst Function select
									{
										case(0):burst_func=1;str_disp(1,16,4);break; 		//burst time
										case(1):burst_func=2;str_disp(1,17,4);break; 		//burst Repeat time 
										case(2):burst_func=3;str_disp(1,12,4);				//burst ON
												write_asf();dds_up_date(); 					//Amplitude set
								  	 			burst_load();								//burst load	
												break;
										case(3):burst_func=0;str_disp(1,13,5);				//burst off
									  			lamp_stop();ini_amp_set();					//cfr1 return & asf return	
												break;
										break;	
									} 
						break;
					}
		}		
	/******************************/
	/*  09 位相ランプ設定         */
	/******************************/
	if (function==9	) 
	 		{	
			  if (phlmp_sel==0){lamp_disp();}else{phase_disp();}							//phlmpsel=0->lamp phlmpsel=1->phase
				switch(key_buf)	
					{	case 1:if(phlmp_sel==0)
									{arr_buf+=1;if(arr_buf>=lamp_max){arr_buf=lamp_max;}lamp_disp();}
								else{pow0_disp+=phase_step;if(pow0_disp<=phase_max){pow0_buf+=phase_10;}else{pow0_disp=phase_max;}phase_disp();}break;	
	  					case 2:if(phlmp_sel==0)
									{
										if(arr_buf>0){arr_buf-=1;}	
										else{lamp_stop();arr_buf=0;}
										lamp_disp();
									}	
								else{if(pow0_disp>=10){pow0_disp-=phase_step;pow0_buf-=phase_10;}else{pow0_disp=0;}phase_disp();}break;		
	  					case 4:break;
	  					case 8:if (phlmp_sel==1){phlmp_sel=0;lamp_disp();}else{phlmp_sel=1;phase_disp();}break;
						break;
					}
			}
	/******************************/
	/*  10 e2prom ReLoad          */
	/******************************/
	if (function==10	) 
	 		{	
				switch(key_buf)	
					{	case 1:ini_load();break;
	  					case 2:eeprom_no+=1;if(eeprom_no>=6){eeprom_no=0;}
							   e2prom_read();LED7SEG_1_PutHex(eeprom_no,8);
							   break;	
	  					case 4:break;
	  					case 8:e2prom_write(frequency,asf_buf);break;
						break;
					}
			}
	key_flug=3;				//key read lady!! 
	}
/******************/
/* ロングキーオン */
/******************/	
	if(key_longon4==1){function=1;key_longon4=0;}											//ファンクション長押し0.5秒以上周波数表示に戻す
	if(key_longon4==2){function=10;key_longon4=0;}											//ファンクション長押し1秒以上10にする。
	if(key_longon8!=0){
						frequency*=10;if(frequency >=f_shift_max){frequency=f_min;}			//ファンクション１長押し、周波数を10倍ずつにする、
				 		freq_set(frequency);freq_disp(0,frequency,8);
				 		keyontim=0;key_longon8=0;											//処理終了（割り込みでキー確認、処理）
					  }	
	goto key_check;	
}
//
/*************************/
/****ルーチン サブ　   ***/
/*************************/
//
/******************/
/*システムタイマー*/
/******************/ 
void system_timer(void)
{
//System Timer
 system_time++;
 if (wait_time>=1){wait_time=wait_time-1;}								//ウェートタイマー１以上ならデクリメント
 
//Burst Timer 
 if(burst_on_buf!=0){burst_on_buf-=1;}									//バーストタイマーデクリメント
 if(burst_rp_buf!=0){burst_rp_buf-=1;}									//バーストリピートタイマーデクリメントt
//key return
 keyontim+=1;
 if(key_flug==3 && key_buf==4)											//ファンクション０キー長押し？
		{
			if(keyontim> key_long_500 && keyontim<key_long_1000)
				{
					key_longon4=1;LED7SEG_1_PutPattern(0x50,1);			//F1戻し、長押し0.5sec以上r表示、key_on_tim_500~1000メインルーチンで処理。
					
				}
			if(keyontim>key_long_1000 && keyontim<key_long_1500)
				{
					key_longon4=2;LED7SEG_1_PutPattern(0x1c,1);			//長押し0.5sec以上u表示、key_on_tim_1000~1500メインルーチンで処理。
				}
			if(keyontim==key_long_1750)
				{
				  key_longon4=3;
				  function+=1;if(function>function_max){function=1;}	//ﾌｧﾝｸｼｮﾝの順次アップ
				  LED7SEG_1_DispInt((int)function,1,2);
				  keyontim=key_long_1500;								//time_return to 1500
				}
		}
 if(key_flug==3 && key_buf==8)											//ファンクション１キー長押し？
		{if(keyontim> key_long_500){key_longon8=1;}						//long_key on flug on (process at main routin)
		}
//key Timer
	if(key_wait!=0){key_wait=key_wait-1;}								//key timer decriment
	key_in:		if((key_flug==0) && ((key_port & 0xf0)!=0xf0))			//KEY OFF && KEY IN  then key FLUG ON & WAIT START
		 		{key_wait=key_wait_val;key_flug=1;
				 keyontim=0;}	//
	key_in1:	if((key_flug==1) && (key_wait==0))						//key flug on & wait timer 0 then key_buffer get prt5 keydata
				{key_buf=((~key_port & 0xf0) >> 4);						//& keyflug set 2(ready get port data)
				key_flug=2;}											// 1-clockwise   2-counter clock wise 4-function 8-digit	
	key_out:	if((key_flug==3) && ((key_port & 0xf0)==0xf0))			//when key flug clear at main routin then key flug=4(ready key_in)
				{key_flug=4;}
	key_enable:	if((key_flug==4) && (key_wait==0))						//key off wait end?
	   			{key_flug=0;keyontim=0;}								//key flug clear ready key input
}
//
/*******************/
/*システムタイマー1*/
/*******************/
//for AM,FM modulation
void system_timer1(void)
{
 M8C_DisableGInt;														//全割込禁止
 if(mod_flug==1)														//ＡＭ変調
 	{
	 if (function==6 | function==1)										//ＡＭ変調、周波数変更ﾌｧﾝｸｼｮﾝのみＡＭ変調 
		{
		 write_8bit(ASF);write_16bit(sine_out[s_step]);dds_up_date();	//amplitude reg write
	 	s_step++;if(s_step>23){s_step=0;}								//next step & check
 		}
	}
 if(fmod_flug==1)
    {
	 if (function==7 | function==1)										//ＦＭ変調、周波数変更ﾌｧﾝｸｼｮﾝのみＦＭ変調 
	 	{
		 write_8bit(FTW0);write_32bit(fsine_out[s_step]);dds_up_date();	//FTW0 reg write
	 	s_step++;if(s_step>23){s_step=0;}								//next step & check
 		}	
	}
 M8C_EnableGInt;														//全割込許可
 } 
/*****************/
/*	ウェート     */
/*****************/
//１ｍｓｅｃ単位でウェート
void wait(int wait_val)
{
 wait_time=wait_val;
 while (wait_time != 0){}
 }
/*****************/
/*　ﾌｧﾝｸｼｮﾝｾｯﾄ　 */
/*****************/ 
////
void function_set(void)
{
 function=function+1;
 if(function>function_max){function=1;}
		 erase_line();													//erase_line
		LED7SEG_1_PutPattern(0x71, 1);LED7SEG_1_PutPattern(0x40, 2);		
		LED7SEG_1_DispInt((int)function,3,2);wait(250);					//250msecのみ表示  
}
/******************/
/*dds_reg_write	  */
/******************/
void write_asf(void)
{ write_8bit(ASF);write_16bit(asf_buf);}								//Amplitude Write
void write_arr(void)
{ write_8bit(ARR);write_8bit(arr_buf);}									//arr write
void write_cfr1(void)
{ write_8bit(CFR1);write_32bit(cfr1_buf);}								//controll1 write
void write_cfr2(void)
{ write_8bit(CFR2);write_24bit(cfr2_buf);}								//controll2 write
void write_pow(void)
{ write_8bit(POW0);write_16bit(pow0_buf);}								//pahase write
void write_ftw(void)
{ write_8bit(FTW0);write_32bit(ftw0_buf);}								//frequency reg write
/******************/
/*周波数ｽﾃｯﾌﾟ表示 */
/******************/ 
void step_dis(long step)
{
int	freq_exp;										
 str_disp(1,0,7);														//S-__^表示
 LED7SEG_1_DispInt(fstep_base,3,2);										//10 表示
 LED7SEG_1_PutPattern(0x40,7);											//"-"表示
 LED7SEG_1_PutHex(fstep_mul,8);											//step 表示(1~9)
 if(fbase10dis==0){LED7SEG_1_PutPattern(0x46, 6);}						//10^表示(-1)
 else{LED7SEG_1_PutHex(fbase10dis-1,6);}								//10^表示
}
/******************/
/*	バースト表示　*/
/******************/
void burst_disp(void)
{
 str_disp(1,11,2);
 LED7SEG_1_DispInt(burst_on_time,3,2);
 LED7SEG_1_DispInt(burst_rp_time,5,4);
 LED7SEG_1_DP(1,4);
}
/******************/
/*	burst load    */
/******************/
void burst_load(void)
{
 burst_on_buf=burst_on_time;
 burst_rp_buf=burst_rp_time;
}
/******************/
/*　　位相表示　　*/
/******************/
void phase_disp(void)
{
str_disp(1,14,2);
LED7SEG_1_DispInt(pow0_disp,4,4);
write_pow();dds_up_date();
}
/******************/
/*　　Lamp表示　　*/
/******************/
void lamp_disp(void)
{
 str_disp(1,15,2);
 if(frequency < f_change_p) 							 				//100khz Lower
 	{lamp_time=arr_buf*lamp_low;}
 else{lamp_time=arr_buf*lamp_high;}						 				//100khz higer
    LED7SEG_1_DispInt(lamp_time,4,5);LED7SEG_1_DP(1,5);	 				//msec 表示		
 write_arr();dds_up_date();
}
//
/*****************/
/*	表示消し	 */
/*****************/
//
void erase_line(void)
{
 char n;
 for(n=1;n<=8;n++){LED7SEG_1_PutPattern(0, n);} 						//erase line
}
//
/*****************/
/*	文字列表示	 */
/*****************/ 
//
void str_disp(char start,char str,char num)
{
 char n;
 int	*disp_str;
 static int f_step_str[]	={0x05,0x1e,0x20,0x20,0x21};				//S-10^x-x
 static int out_ofs_str[]	={0x17,0x0f,0x05,0x20};						//oFs_"volt"  
 static int ofs_stp_str[]	={0x05,0x22,0x18,0x1e,0x20,0x20,0x1e};		//stp-"volt"
 static int swp_start_str[]	={0x05,0x05,0x1e};							//SS-"freq"
 static int swp_end_str[]	={0x05,0x0e,0x1e,};							//SE-"freq"
 static int swp_run_str[]	={0x05,0x18,0x1e,0x05,0x22,0x0a,0x19,0x22};	//SP-start
 static int swp_stop_str[]	={0x05,0x18,0x1e,0x05,0x22,0x17,0x18};		//SP-stop
 static int out_val_str[]	={0x00,0x22,0x1e,0x20,0x20,0x20,0x0d,0x0b}; //OT-___db
 static int out_step_str[]	={0x00,0x05,0x1e,0x20,0x20,0x20,0x0d,0x0b}; //OS-___db"	
 static int am_mod_str[]	={0x0a,0x16,0x17,0x0d,0x1e};				//anod-"	
 static int fm_mod_str[]	={0x0f,0x16,0x17,0x0d,0x1e};				//Fnod-"
 static int brust_str[]		={0x0b,0x19,0x1e};							//br-"
 static int on_str[]		={0x0b,0x19,0x1e,0x00,0x16};				//br-on"
 static int off_str[]		={0x0b,0x19,0x1e,0x00,0x0f,0x0f};			//br-off"
 static int br_bu[]			={0x0b,0x19,0x1e,0x0b,0x1a};				//br-bu"
 static int br_br[]			={0x0b,0x19,0x1e,0x0b,0x19};				//br-br"
 static int phase_str[]		={0x18,0x11,0x1e};							//ph-"
 static int lamp_str[]		={0x15,0x18,0x1e};							//LP-"
 erase_line();							//erase_line
	switch(str)
	{
 		case (0):	disp_str=f_step_str;	break;
 		case (1): 	disp_str=out_ofs_str;	break;
 		case (2): 	disp_str=ofs_stp_str;	break; 
 		case (3): 	disp_str=swp_start_str;	break;
 		case (4):	disp_str=swp_end_str;	break;
		case (5):	disp_str=swp_run_str;	break;
		case (6):	disp_str=swp_stop_str;	break;
		case (7):	disp_str=out_val_str;	break;
		case (8):	disp_str=out_step_str;	break;
		case (9):	disp_str=am_mod_str;	break;
		case (10):	disp_str=fm_mod_str;	break;
		case (11):	disp_str=brust_str;		break;
		case (12):	disp_str=on_str;		break;
		case (13):	disp_str=off_str;		break;
		case (14):	disp_str=phase_str;		break;
		case (15):	disp_str=lamp_str;		break;
		case (16):	disp_str=br_bu;			break;
		case (17):	disp_str=br_br;			break;
		break;
 	}
 for(n=start;n<=(start+num);n++)
 	{
		disp_7seg(*disp_str, n);disp_str++;//display line
	}
}
/*******************/
/*DDS周波数セットt */
/*******************/
//周波数100KHZ以上でクロックを25MHZ,400MHZを切り替える
void freq_set(long freq)
{ 
 M8C_DisableGInt;														//切替時割込みを入れない。 	
 if(freq>=f_change_p)//100khz over
  {
   	cfr2_buf=cfr2_ini;asf_buf&=0x3fff;
   	ftw0_buf=freq*mul/10;
  }
 else
  {	
  	cfr2_buf=cfr2_low;asf_buf|=0xc000;
   	ftw0_buf=freq*mul2/10;
  }
  write_asf();															//lamp X8
  write_cfr2();															//reg2 write
  write_ftw();dds_up_date();
 M8C_EnableGInt;
}
/*****************/
/* 周波数表示    */
/*****************/
void freq_disp(char disp_start,long freq,char digit)
{
 int    stat;
 int 	n;
 char   end_flug;
 char	*disp_str; 
//display Frequency
	if(freq>=f_change_p)
	 {disp_str=ftoa(ftw0_buf/mul,&stat);}								//<100khz	
	else
	 {disp_str=ftoa(ftw0_buf/mul2,&stat);}								//>100khz	   

//Display & find "." end add"000xxx"	 
	 end_flug=0; 
	 for(n=1;n<=digit;n++)
	 {
     if	 (*disp_str==0){end_flug=1;}
	 if	 (*disp_str==0x2e){n-=1;LED7SEG_1_DP(1,disp_start+n);disp_str++;}//"." process
	 else{
	        if(end_flug==1){disp_7seg(0x0, disp_start+n);}
	 		else{disp_7seg(*disp_str -0x30, disp_start+n);disp_str++;}	//display line
	 	}
	 }
//For Upper 10Mhz "." display	
	if(frequency>=100000000 && frequency<999999999)//10Mhz~99Mhz(frequency-*10)
	  {
	   	LED7SEG_1_DP(1,2);LED7SEG_1_DP(1,5);
	  }
	if(frequency>=1000000000)//<100Mhz 
	  {
	   	LED7SEG_1_DP(1,3);LED7SEG_1_DP(1,6);	
	  }

}
//
/*****************/
/*	7セグ表示    */
/*****************/
void disp_7seg(char pat,char digit)
{
char disp7buf;
  LED7SEG_1_PutPattern(disp_7seg_pat[pat],digit);           			//pat get const char
}
/*****************/
/*ｄＢ変換＆表示 */
/*****************/
//change & store asf_buf(amplitude buffer)& write DDS_asf
void db_change(int db)
{
  int n,buf;
  float dbm=1;
  if(db==0){asf_buf|=asf_maxvalue;}  									//load_0db/m 50ohm
  else{for (n=1;n<=db;n++){dbm=dbm*log0_1db;}
	asf_buf&=0xc000;
	asf_buf|=(int)(asf_maxvalue/dbm);
  }
  str_disp(1,7,7);														//Display OT-xx.xdb
  if(db<=47)															//lower 47 out_db-47
     {
	   LED7SEG_1_DispInt(47-db,4,3);
	   LED7SEG_1_PutPattern(0,3);										//- erase
	 }
	 
  if(db>47)																//higher  47 out_db 47-1
  	{
	  LED7SEG_1_DispInt(db-47,4,3);
    }
	LED7SEG_1_DP(1,5);
  	ini_amp_set();
}
/*****************/
/*dacｵﾌｾｯﾄ表示　 */
/*****************/
//dac_out&display
void dac_dis(void)
{
 int dac_o;
 str_disp(1,1,4);
 DAC9_1_WriteStall(out_offset);
 if (out_offset >=dac_ini_v)											//offset+display
 	{	LED7SEG_1_PutPattern(0x40,4);									//マイナス表示
		dac_o=(out_offset - dac_ini_v)*dc_step;							//dac_step_v*dc_gain;
	}
 else
  	{	dac_o=(dac_ini_v - out_offset)*dc_step;}						//dac_step_v*dc_gain;
	LED7SEG_1_DispInt(dac_o,5,4);
}
/******************/
/*Lampストップ設定*/
/******************/
void lamp_stop(void)
{
    dds_port&=~dds_osk;
	cfr1_buf&=~CFR1_OSK_AUTO;
	write_cfr1();
	dds_up_date();
}
/*****************/
/*	DDS リセット */
/*****************/
//dds_hardware reset
void reset_dds(void)
{ dds_port=dds_port | dds_rst;wait(1);dds_port=dds_port & ~dds_rst;}
/******************/
/*Amﾃﾞ-ﾀｰﾃｰﾌﾞﾙ作成*/
/******************/ 
//変調率10%～100%;
void sin_set(char mod)
{
 char n,m_div;
 //0x0000,0x0847,0x0fff,0x169f,0x1bb5,0x1ee7,0x1fff,0x1ee7,0x1bb5,0x169f,0x0fff,0x0847,0x0000//
 // 0	  15	 30		45		60	  75     90     105	   120    135    150    165	   180*/
  m_div=mod_div(mod);	  	
  for (n=0;n<13;n++){ sine_out[n]=(0x1fff+(sin_dt[n]/m_div)); }			//plus side data make & store
  for (n=0;n<12;n++){ sine_out[n+12]=0x1fff-(sin_dt[n]/m_div);}			//minus side data make & store
  Timer8_2_EnableInt();				    								//enable interrupt after Data Make	
 }
 
char mod_div(char mod)
{
 char m_div;
 switch(mod) //modlation diveide set
 		{		case 100:m_div=1;break;			//100%
				case  50:m_div=2;break;			//50%	
				case  30:m_div=3;break;			//33.3%
				case  20:m_div=5;break;			//20%	
				case  10:m_div=10;break;		//10%	
				break;
		}
 return(m_div);
}
void mod_set(char mod)
{
 switch(mod)
		{
				case(100):modu_level=10;break;	//100->10
				case(10):modu_level=20;break;	//10->20
				case(20):modu_level=30;break;	//20->30
				case(30):modu_level=50;break;	//30->50
				case(50):modu_level=100;break;	//50->100
				break;
		}

}

/******************/
/*Am変調リセット　*/
/******************/ 
//ＡＭ変調ＯＦＦ時振幅を戻す
void ini_amp_set(void)
{
	write_asf();dds_up_date();		  			//return condition
}
/*******************/
/*Fmﾃﾞ-ﾀｰﾃｰﾌﾞﾙ作成 */
/*******************/ 
//mod 10 to 100;
void fsin_set(char mod)
{
 char n,m_div;
//0x000,0x4bd3,0x927b,0xcf29,0xfdb7,0x11afc,0x124f8,0x11afc,0xfdb7,0xcf29,0x927b,0x4bd3,0x0000
//	0	  15	 30		45		60	  75     90      105	   120    135    150   165	  180
  m_div=mod_div(mod);
  if(frequency>=fm_mod_limit)		
  	{for (n=0;n<13;n++){{fsine_out[n]=(frequency/10+(fsin_dt[n])/m_div)*mul;}}
	for (n=0;n<12;n++) {{fsine_out[n+12]=(frequency/10-fsin_dt[n]/m_div)*mul;}}
	Timer8_2_EnableInt();}
 else{fmod_flug=0;Timer8_2_DisableInt();}
}
/*****************/
/* write 8bit    */
/*****************/
void write_8bit(char dt)
{
 char n;
 while( ! (SPIM_1_bReadStatus() & SPIM_1_SPIM_TX_BUFFER_EMPTY ) );
 SPIM_1_SendTxData(dt);
}
/*****************/
/* write 16bit    */
/*****************/
void write_16bit(int dt)
{
 char  *cp;
 cp=(char*) &dt;
 write_8bit(cp[0]); write_8bit(cp[1]);
}
/*****************/
/* write 24bit    */
/*****************/
void write_24bit(long dt)
{
 char  *cp;
 cp=(char*) &dt;
 write_8bit(cp[1]); write_8bit(cp[2]); write_8bit(cp[3]);
}
/*****************/
/* write 32bit    */
/*****************/
void write_32bit(long dt)
{
  char  *cp;
  cp=(char*) &dt;
  write_8bit(cp[0]); write_8bit(cp[1]); write_8bit(cp[2]);write_8bit(cp[3]);
}
/*****************/
/*DDS update	 */
/*****************/
void dds_up_date(void)
{
 int n;
 dds_port=dds_port | dds_update;										//update high
 dds_port=dds_port & ~dds_update;										//update low	
}

/*****************/
/*　initial		*/
/*****************/ 
void ini_load(void)
{
//key 
	key_longon4=0;														//long key on function0 clr
	key_longon8=0;														//long key on function0 clr
//DDS initial Write & DDS Buffer initial
	cfr1_buf=cfr1_ini;													//sin_on_reg0,osk eable
	cfr2_buf=cfr2_ini;													//x16,xtal,pll_400
	asf_buf=asf_ini;													//out scall max
	arr_buf=arr_ini;													//lamp
	ftw0_buf=ftw0_ini;													//1khz
	pow0_buf=pow0_ini;													//phase
	write_cfr1();														//reg0  DDS controll0
	write_cfr2();														//reg1  DDS controll1
	write_asf();														//reg2	DDS amplitude
	write_arr();														//reg3	DDS lamp
	write_ftw();														//reg4	DDS Frequency
	write_pow();														//reg5	DDS phase
	dds_up_date();														//all dds data update
// initial freqency set 
	frequency=frequency_ini;											//1khz
	freq_step=fstep_ini*10;												//1hz set
	fbase10x=fstep_ini*10;												//10^0=1
	fbase10dis=fstep_ini_10s+1;											//10^ For Display only
	fstep_mul=fstep_mul_ini;											//freqency step=1  (1 to 9)
	freq_set(frequency);												//freqency set
	freq_disp(0,frequency,8);											//frequency display	
//	DAC output offset initial
	ofset_step=dac_stp_ini;												//8mV * dc__gain
	out_offset=dac_ini_v;												//
	DAC9_1_WriteStall(out_offset);										//ofset_write	
//  sweep initial
	swp_sel=1;															//store start set
	swp_onoff=0;														//sweep off
	swp_step=swp_step_val;												//sweep step 1hz
    swp_start=swp_start_val;											//sweep start 10hz
	swp_end=swp_end_val;												//sweep end 20khz
// output variable value
	out_db=out_db_ini;													//out ini att=0
	out_step=out_step_ini;												//out step ini 0.1db
//AM mod_ini	
	modu_level=modu_level_ini;											//initial mod 30%
	mod_flug=0;															//modulation none=0,start=1
	s_step=0;															//mod_data_counter(use AM,FM)
//FM mod ini
	fmod_flug=0;														//modulation none=0,start=1	
//burst ini
	burst_on_time=burst_on_ini;											//burst on time 1msec to 99msec
    burst_rp_time=burst_rp_ini;											//burst repeat time 2 to 2500msec
	burst_func=0;														//burst off setting
	pow0_disp=0;														//phase display clr
}
//
/*****************/
/*e2prom_write   */
/*****************/
//
void e2prom_write(long freq,int amp)
{
 char n;
 char  *pot;
 E2PROM_1_E2Read(0,e2prom,36);		//read eeprom all data
 n=(eeprom_no)*6;	
 
 pot=(char*) &freq;
 e2prom[n+0]=pot[0];
 e2prom[n+1]=pot[1];
 e2prom[n+2]=pot[2];
 e2prom[n+3]=pot[3];
 
 pot=(char*) &amp;
 e2prom[n+4]=pot[0];
 e2prom[n+5]=pot[1];
 E2PROM_1_bE2Write(0,e2prom,36,temp);
}
/*****************/
/*e2prom_read    */
/*****************/
void e2prom_read(void)
{
char n;
char  *pot;
 E2PROM_1_E2Read(0,e2prom,36);		//read eeprom 1 block
 n=(eeprom_no)*6;						

 pot=(char*) &frequency;
 pot[0]=e2prom[n+0];
 pot[1]=e2prom[n+1];
 pot[2]=e2prom[n+2];
 pot[3]=e2prom[n+3];
 
 pot=(char*) &asf_buf;
 pot[0]=e2prom[n+4];
 pot[1]=e2prom[n+5];
 freq_set(frequency);freq_disp(0,frequency,8);
 write_asf();dds_up_date();
}


